%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% OCR.cls, v0.1, 5/Nov/2021
% Based on Overleaf's  GigaScience Template
% Modified by Paulo S. Polito & Olga T. Sato for
% Ocean and Coastal Research
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% 
\ProvidesClass{OCR}[9/7/2021, v0.1]
%\LoadClass[twoside,twocolumn,a4paper]{article}
\RequirePackage{ifdraft}
%\LoadClass[twoside,twocolumn,a4paper]{article}
\ifdraft{
  \LoadClass[oneside,onecolumn,a4paper]{article}}{
  \LoadClass[twoside,twocolumn,a4paper]{article}}
\ifdraft{\RequirePackage[displaymath,mathlines]{lineno}}{}
\RequirePackage[T1]{fontenc}
\RequirePackage[utf8]{inputenc}
\RequirePackage{microtype}
\RequirePackage{tgheros}
\renewcommand*\familydefault{\sfdefault}
\RequirePackage{amsmath}
\RequirePackage{amssymb}
%\RequirePackage[mathbf,mathcal,text-hat-accent]{euler}
\RequirePackage{cmbright}
% Math font
\renewcommand{\rmdefault}{cmbr}
\RequirePackage{relsize}
\RequirePackage{ragged2e}
\RequirePackage{xcolor}
\RequirePackage{colortbl}
% \RequirePackage[italic]{mathastext}
\RequirePackage{graphicx}
\RequirePackage{etoolbox,xpatch}
\RequirePackage{environ}
\RequirePackage{lastpage}
\RequirePackage{rotating}
\RequirePackage{lscape}
\RequirePackage{afterpage}
\RequirePackage[absolute]{textpos}
\RequirePackage{url}
\RequirePackage{newfloat}
\RequirePackage{mdframed}
\RequirePackage{titlesec}
\RequirePackage{scrextend}

% Font definition for the main text
\fontfamily{qhv}\selectfont
\ifdraft{
\changefontsizes[22pt]{11pt}
}{
\changefontsizes[13pt]{9.5pt}
}

\RequirePackage{calc}
\RequirePackage{geometry}
\geometry{includefoot,
  % hmargin=4pc+6.64pt,
  hmargin=21mm,
  bottom=2pc+10pt,
  top=5pc+6pt,
  headsep=2pc,
  headheight=17.5pt,
  footnotesep=1pc+6pt,
  columnsep=10mm}
\setlength{\parindent}{12pt}


\definecolor{jcolor}{RGB}{5.0,47.0,79.0}
\definecolor{jcolor1}{RGB}{0.0,91.4,125.0}
\definecolor{jcolor2}{RGB}{22.3,201.6,155.8}
\definecolor{jcolor3}{RGB}{170.5,206.6,224.5}

\RequirePackage[colorlinks,allcolors=black,urlcolor=jcolor1]{hyperref}
\ifdraft{
  \renewcommand\thelinenumber{\color{red}\arabic{linenumber}}
}{}

\RequirePackage[noblocks]{authblk}

% Journal name and visual identity
\def\@jname{Ocean and Coastal Research}
\def\@jnick{OCR}
\def\@jlogo{logotipo_ocr_header.png}
\def\@cclogo{cc_logo.png}
\newcommand{\jname}[1]{\def\@jname{#1}}
\newcommand{\jnick}[1]{\def\@jnick{#1}}
\newcommand{\jlogo}[1]{\def\@jlogo{#1}}
\newcommand{\cclogo}[1]{\def\@cclogo{#1}}

% Article bibliographic info ### for editors to fill ###
\def\@jyear{20xx}
\def\@jvolume{0}
\def\@jnumber{0}
\def\@jstartpage{1}
\def\@jpapercat{}
\def\@jissn{}
\def\@jdoi{}
\def\@jeditor{}
\def\@jsubmitted{}
\def\@japproved{}
\newcommand{\jyear}[1]{\def\@jyear{#1}}
\newcommand{\jvolume}[1]{\def\@jvolume{#1}}
\newcommand{\jnumber}[1]{\def\@jnumber{#1}}
\newcommand{\jstartpage}[1]{\def\@jstartpage{#1}}
\newcommand{\jpapercat}[1]{\def\@jpapercat{#1}}
\newcommand{\jissn}[1]{\def\@jissn{#1}}
\newcommand{\jdoi}[1]{\def\@jdoi{#1}}
\newcommand{\jeditor}[1]{\def\@jeditor{#1}}
\newcommand{\jsubmitted}[1]{\def\@jsubmitted{#1}}
\newcommand{\japproved}[1]{\def\@japproved{#1}}

% These are for the authors to fill
\def\@runningauthor{}
\def\@runningtitle{}
\def\@corraddress{}
\def\@authnotes{}
\def\@corrauths{}
\newcommand{\runningauthor}[1]{\def\@runningauthor{#1}}
\newcommand{\runningtitle}[1]{\def\@runningtitle{#1}}
\newcommand{\corraddress}[1]{\def\@corraddress{#1}}
\newcommand{\authnote}[1]{\appto{\@authnotes}{#1\par}}
\newcommand{\corrauth}[1]{\appto{\@corrauths}{#1\par}}

% Headers and footers
\newcommand{\footfont}{\fontfamily{qhv}\fontsize{7.5pt}{10pt}\selectfont}
\RequirePackage[flushmargin,bottom,norule]{footmisc}
%\appto{\footnotelayout}{\fontfamily{qhv}\fontsize{7.5pt}{10pt}\selectfont}
\appto{\footnotelayout}{\footfont}

\RequirePackage{fancyhdr}
\fancyhf{}
\renewcommand{\footrule}{\color{jcolor1}\rule{\textwidth}{0.2pt}}
\renewcommand{\headrule}{}
% this makes the boxed page numbers
\newcommand\boxpage{
  \raisebox{3.6pt}[0pt][0pt]{
    \color{lightgray}\rule[-0.4ex]{4.5ex}{2.3ex}
    \hspace*{-3.2ex}%%
    \makebox[3pt]{\textcolor{jcolor}{\thepage}}%%
    \hspace*{1ex}
  }
}
\fancyfoot[R]{%
  \hspace*{12pt}%
  \fontfamily{qhv}\fontsize{7.8pt}{10pt}\selectfont%
  \color{jcolor}%
  \hspace{1em}\raisebox{3pt}{
    \textit{\@jname} \@jyear, v\,\@jvolume:e\,\@jnumber
  }
  \textbf{\boxpage}%
}
\fancyhead[R]{%
  \fontfamily{qhv}\fontsize{7.8pt}{10pt}\selectfont%
  \color{gray}%
  \@runningtitle%
  %\hspace{1em}\raisebox{-0.5pt}{|}\hspace{1em}%
  %\textbf{\thepage}%
  \hspace*{12pt}%
}
\fancyhead[L]{%
  \fontfamily{qhv}\fontsize{7.8pt}{10pt}\selectfont%
  \color{gray}%
  \@runningauthor%
  %\hspace{1em}\raisebox{-0.5pt}{|}\hspace{1em}%
  %\textbf{\thepage}%
  \hspace*{12pt}%
}

\fancypagestyle{plain}{%
  \fancyhf{}
  \renewcommand{\headrule}{}
  % footer for the 1st page
  \fancyfoot[R]{%
    \fontfamily{qhv}\fontsize{7.8pt}{10pt}\selectfont%
    \color{jcolor}%
    \hspace{1em}\raisebox{3pt}{
      \textit{\@jname} \@jyear, v\,\@jvolume:e\,\@jnumber
  }
  \textbf{\boxpage}%
  }
}
%%% Makes orcid links for authors
%%%-------- Note: this was copied from package orcidlink.sty ----------
\RequirePackage{tikz}
\ProcessOptions\relax
\usetikzlibrary{svg.path}
\definecolor{orcidlogocol}{HTML}{A6CE39}
\tikzset{
  orcidlogo/.pic={
    \fill[orcidlogocol] svg{M256,128c0,70.7-57.3,128-128,128C57.3,256,0,198.7,0,128C0,57.3,57.3,0,128,0C198.7,0,256,57.3,256,128z};
    \fill[white] svg{M86.3,186.2H70.9V79.1h15.4v48.4V186.2z}
                 svg{M108.9,79.1h41.6c39.6,0,57,28.3,57,53.6c0,27.5-21.5,53.6-56.8,53.6h-41.8V79.1z M124.3,172.4h24.5c34.9,0,42.9-26.5,42.9-39.7c0-21.5-13.7-39.7-43.7-39.7h-23.7V172.4z}
                 svg{M88.7,56.8c0,5.5-4.5,10.1-10.1,10.1c-5.6,0-10.1-4.6-10.1-10.1c0-5.6,4.5-10.1,10.1-10.1C84.2,46.7,88.7,51.3,88.7,56.8z};
  }
}
\newcommand{\@OrigHeightRecip}{0.003}
\newlength{\@curXheight}
\DeclareRobustCommand\orcidlink[1]{%
\texorpdfstring{%
\setlength{\@curXheight}{\fontcharht\font`X}%
\href{https://orcid.org/#1}{\XeTeXLinkBox{\mbox{%
\begin{tikzpicture}[baseline={(0,-0.4)}, yscale=-\@OrigHeightRecip*\@curXheight,
xscale=\@OrigHeightRecip*\@curXheight,transform shape]
\pic{orcidlogo};
\end{tikzpicture}%
}}}}{}}
%%%-------------------------------------------------------
\pagestyle{fancy}

\AtBeginDocument{%
  \newsavebox{\@gscitedetails}
  \newlength{\@gscitedetailsheight}
  \savebox{\@gscitedetails}{
    \parbox{\textwidth-89.5mm}{
      \begin{flushright}
        \vspace{0.5mm}
        \fontfamily{qhv}\fontsize{14pt}{16pt}\selectfont\bfseries%
        \textcolor{jcolor1}\@jpapercat\par
        \vspace{6.5mm}
        \fontfamily{qhv}\fontsize{8.5pt}{9pt}\selectfont\mdseries%
        \@jdoi\par
        \vspace{2mm}
        \textcolor{jcolor1}\@jissn\par
        \vspace{\dimexpr 8pt-1em\relax}
      \end{flushright}
    }}%
  \settototalheight{\@gscitedetailsheight}{\usebox{\@gscitedetails}}%
  %%%% 
  \fontfamily{qhv}\selectfont
}
% This is related to the corresponding author
\RequirePackage{alphalph}
\newalphalph{\fnsymbolmult}[mult]{\@fnsymbol}{5}
\newcounter{caut}
\setcounter{caut}{1}
\newcommand{\cauthfn}[1]{%
  \fnsymbolmult{#1}%
}

% This is related to the authors and affiliation lists
\renewcommand\Authands{ and }
\renewcommand\AB@affilsepx{, }
\renewcommand{\Authfont}{\fontfamily{qhv}\fontsize{10pt}{12pt}\selectfont}
\renewcommand{\Affilfont}{\fontfamily{qhv}\fontsize{8.5pt}{11pt}\selectfont}
\setlength{\affilsep}{21pt-9pt}

\AtBeginDocument{
  \renewcommand{\@maketitle}{%
     \textblockorigin{22mm}{13.5mm}
    % This is the main logo at the top of the first page, left side
    \begin{textblock*}{21pc}(0pt,0pt)      
      \includegraphics[height=24.2mm, draft=false]{\@jlogo}
    \end{textblock*}
    % This is the text block with issn, doi and category at the top of
    % the first page, right side
    %\begin{textblock*}{\textwidth-21pc}(21pc,0pt)
    \begin{textblock*}{\textwidth-15pc}(20pc,0pt)
      \usebox{\@gscitedetails}
    \end{textblock*}%
    % This is the text block with the title and authors
    % from package authblk
    \ifdraft{\,\vspace{8mm}}{\,\vspace{15mm}}
    
    \setlength{\affilsep}{7mm}
    \begin{center}
      \linespread{0.8}
      {\fontfamily{qhv}\fontsize{16pt}{27pt}\mdseries\@title\par}
      \vspace{3.3mm}
      \@author\par
    \end{center}
    \vspace{1mm}
    {%
      \renewcommand{\cauthfn}[1]{%
        \textsuperscript{\fnsymbolmult{##1}} Corresponding author: \color{jcolor} %
      }
      {\fontfamily{qhv}\fontsize{8pt}{10pt}\selectfont\@corrauths\par}%
    }
    \vspace{2.58mm}
  }
}

\RequirePackage[style]{abstract}
\setlength{\absleftindent}{0pt}
\setlength{\absrightindent}{0pt}
\setlength{\absparindent}{12pt}
\setlength{\absparsep}{0pt}
\setlength{\abstitleskip}{16pt-8pt-\baselineskip}
\renewcommand{\abstractnamefont}{\usefont{T1}{qhv}{b}{sc}\fontsize{14pt}{16.5pt}\selectfont\color{jcolor}}
\renewcommand{\abstitlestyle}[1]{{\abstractnamefont #1}}
\ifdraft{
  \renewcommand{\abstracttextfont}{\fontfamily{qhv}\fontsize{10pt}{20pt}\selectfont}
}{
  \renewcommand{\abstracttextfont}{\fontfamily{qhv}\fontsize{9.5pt}{13pt}\selectfont}
}
\preto{\abstract}{%
  {\noindent\rule{\hsize}{0.2pt}}\par
  \vspace*{5.5mm}
}
\appto\abstract{\noindent\justifying\ignorespaces  \ifdraft{\linenumbers}{}}
\preto\endabstract{\par}

\ifdraft{
  \newenvironment{keywords}
  {\vspace*{\dimexpr 19pt-8pt-\baselineskip\relax}%
    \noindent\fontfamily{qhv}\fontsize{10pt}{20pt}\selectfont\textbf{\color{jcolor}Descriptors\normalcolor}: \ignorespaces}%
  {\par}
}{
  \newenvironment{keywords}
  {\vspace*{\dimexpr 19pt-8pt-\baselineskip\relax}%
    \noindent\fontfamily{qhv}\fontsize{9.5pt}{12pt}\selectfont\textbf{\color{jcolor}Descriptors\normalcolor}: \ignorespaces}%
  {\par}  
  }

%-----------------------------------------------------------------------------
  \ifdraft{
  \NewEnviron{frontmatter}{%   
    \BODY%
    \vspace*{\dimexpr 16pt-3pt-1em\relax}
    {\noindent\rule{\hsize+4pc+6.64pt}{0.2pt}}\par
    \vspace*{\dimexpr 23pt-1em\relax}%
    % Not actually a figure, but a container float that goes to the bottom of page 1
    \begin{figure*}[b!]
      \fontfamily{qhv}\fontsize{6.5pt}{9.5pt}\selectfont%
      \rule{0.25\textwidth}{0.2pt}\par%
      Submitted: \@jsubmitted\par
      Editor: \@jeditor\par\vspace{5pt}
      \color{jcolor2}
      \fontfamily{qhv}\fontsize{18pt}{22pt}\selectfont%
      Confidential Manuscript Under Review, Do Not Distribute.\normalcolor 
    \end{figure*} 
  }
}{
  \NewEnviron{frontmatter}
  {\twocolumn[%
    \BODY
    % space after abstract 
    \vspace*{3.5mm}
    % this is the rule below the abstract
    {\noindent\rule{\hsize}{0.2pt}}\par
    % space before first section title
    \vspace*{6.7mm}
    ]
    \begin{figure}[b!]
      \fontfamily{qhv}\fontsize{6.5pt}{9.5pt}\selectfont%
      \rule{\dimexpr 0.25\textwidth-9pt\relax}{0.2pt}\par%
      Submitted: \@jsubmitted\par
      Approved: \@japproved\par
      Editor: \@jeditor\par\vspace{5pt}
      \parbox{0.09\textwidth}{\includegraphics[width=0.08\textwidth]{\@cclogo}}\parbox{0.39\textwidth}{© \@jyear\, The authors. This is an open access article distributed under
        the terms of the Creative Commons license.}\vspace{-3.5em}
    \end{figure}
  }
}
\setcounter{secnumdepth}{0}
%\titleformat*{\section}{\fontfamily{qhv}\fontsize{12pt}{14pt}\bfseries\scshape\color{jcolor}}
%\titleformat*{\section}{\usefont{T1}{qhv}{b}{sc}\fontsize{12pt}{14pt}\selectfont\color{jcolor}}
\titleformat{\section}[block]{\usefont{T1}{qhv}{b}{sc}\fontsize{12pt}{14pt}\selectfont\color{jcolor}}{}{0em}{\MakeUppercase}
\titlespacing*{\section}{0pt}{26.5pt-1em}{16pt-1em}
%\titleformat*{\subsection}{\fontfamily{qhv}\fontsize{10pt}{12pt}\bfseries\scshape\color{jcolor}}
\titleformat*{\subsection}{\usefont{T1}{qhv}{b}{sc}\fontsize{10pt}{12pt}\selectfont\color{jcolor}}
\titlespacing*{\subsection}{0pt}{2pc-1em}{17pt-1em}
\titleformat*{\subsubsection}{\usefont{T1}{qhv}{b}{it}\selectfont}
\titlespacing*{\subsubsection}{0pt}{\baselineskip}{0pt}
\titleformat{\paragraph}[runin]{\normalsize\itshape}{\theparagraph}{0pt}{}[.\enspace]
\titlespacing*{\paragraph}{0pt}{\baselineskip}{0pt}
\titleformat{\subparagraph}[runin]{\relsize{-1}\uppercase}{\thesubparagraph}{0pt}{}[.\enspace]
\titlespacing*{\subparagraph}{0pt}{\baselineskip}{0pt}

\RequirePackage{enumitem}
\setlist{noitemsep}
\setlist[itemize]{leftmargin=12pt,topsep=16pt-1em}
\setlist[enumerate]
{itemindent=14pt,topsep=16.8pt-1em,
  label={\roman*.},labelsep=7pt,
  labelwidth=*,leftmargin=*,align=right}

\ifdraft{\linenumbers}{}

% quotes and epigraphs
\RequirePackage{quoting}
\newcommand{\quotefont}{\fontfamily{qhv}\fontsize{6.5pt}{9.5pt}\selectfont}
\quotingsetup{vskip=16pt-1em,indentfirst=false,font={quotefont},leftmargin=12pt,rightmargin=12pt}

\renewenvironment{quote}{\begin{quoting}}{\end{quoting}}

\renewenvironment{quotation}{\begin{quoting}}{\end{quoting}}

\newenvironment{epigraph}[1]
{\begin{quoting}[font={itshape,fontsize{7pt}{10.5pt}},vskip=15pt-1em,leftmargin=0pt,rightmargin=0pt]%
    \def\@quotesource{#1}}
  {\par\vspace{\dimexpr 15pt-1em\relax}{\upshape---\@quotesource}\end{quoting}}

% Space above/below equations
\g@addto@macro\normalsize{%
  \setlength\abovedisplayskip{\baselineskip}%
  \setlength\belowdisplayskip{\baselineskip}%
  \setlength\abovedisplayshortskip{\baselineskip}%
  \setlength\belowdisplayshortskip{\baselineskip}%
}

\RequirePackage{stfloats}
\RequirePackage{booktabs}
\RequirePackage{tabularx}
% Left-, right- and center-aligned auto-wrapping column types
\newcolumntype{L}{>{\raggedright\arraybackslash}X}
\newcolumntype{R}{>{\raggedleft\arraybackslash}X}
\newcolumntype{C}{>{\centering\arraybackslash}X}

\AtBeginEnvironment{tabularx}{%
  \fontfamily{qhv}\fontsize{7pt}{10pt}\selectfont
}
\AtBeginEnvironment{tabular}{%
  \fontfamily{qhv}\fontsize{7pt}{10pt}\selectfont
}

\setlength{\aboverulesep}{11pt-1em}
\setlength{\belowrulesep}{11pt-1em}
\setlength{\heavyrulewidth}{0.5pt}
\setlength{\lightrulewidth}{0.5pt}
\arrayrulecolor{jcolor}


\newcommand{\tnote}[1]{\textsuperscript{\textit{#1}}}
\newlist{tablenotes}{itemize}{1}
\setlist[tablenotes]{label={},labelsep=0pt,leftmargin=0pt,topsep={\dimexpr 12pt-1em\relax}}
\appto{\tablenotes}{\fontfamily{qhv}\fontsize{6pt}{9pt}\selectfont}

\RequirePackage[tableposition=top]{caption}
\DeclareCaptionFont{figcaptionfont}{\fontfamily{qhv}\fontsize{6pt}{9pt}\selectfont}
\DeclareCaptionFont{tabcaptionfont}{\fontfamily{qhv}\fontsize{7pt}{9pt}\selectfont}
\captionsetup{justification=justified,singlelinecheck=false,labelfont={bf},labelsep=period}
\captionsetup*[figure]{font=figcaptionfont,skip=10pt}
\captionsetup*[table]{font=tabcaptionfont,skip=10pt-1em}

% Skips for floats
\setlength{\floatsep}{1pc+6pt}
\setlength{\intextsep}{1pc+6pt}
\setlength{\textfloatsep}{1pc+6pt}

  
% References
\RequirePackage{harvard}
\bibliographystyle{ocr}
\newcommand{\HARVARDAND}{\harvardand}
\citationmode{abbr}